/*
 * KheperaThread.cpp
 *
 *  Created on: 6 janv. 2012
 *      Author: chafeek
 */

#include "KheperaThread.h"
#include "KheperaController.h"
#include "Global.h"
#include <stdio.h>

extern mqd_t msgQueueIaToKhepera;

KheperaThread::KheperaThread() {

}

void KheperaThread::start()

{
	pthread_create(&thread, NULL, run, NULL);
}

void KheperaThread::stop()
{

	//TODO : arreter le thread

}

void* KheperaThread::run(void* data)
{
	//Attendre un msg de la boite aux lettres et executer la commande
	//Envoyer les commandes au khepera
	//Initialisation des Khepera 1 et 2


	KheperaController* kheperas[2];

	kheperas[0] = new KheperaController(new std::string("/dev/ttyUSB0"));
	kheperas[1] = new KheperaController(new std::string("/dev/ttyUSB1"));

	//A chaque itération
	unsigned int prio = 0;
	struct msgIaToKhepera receivedData;
	printf("Thread Khepera lancé\n");
	while(true)
	{
		//msgrcv(msgQueueIaToKhepera, &receivedData, sizeof(struct msgIaToKhepera)-sizeof(long), 2, 0);
		mq_receive (msgQueueIaToKhepera, (char*)&receivedData, sizeof(struct msgIaToKhepera), &prio);

		char commande = receivedData.commande;
		int robot = receivedData.robot;
		int angle = (receivedData.p1)%360;
		int walkTime;
		//Traitement des commandes
		switch (commande) {
		case COMMANDE_SHOOT:
			printf("commande shoot reçue par le robot %d\n", robot);
			kheperas[robot]->shoot(-1);
			break;
		case COMMANDE_WALK:
			printf("commande walk reçue par le robot %d\n", robot);
			//kheperas[robot]->walkDistance(receivedData.p1, 70);

			if (receivedData.p2 == 1) {
				walkTime = (int) (double)receivedData.p1 * (120.0 / 2000.0) * 1000000.0;
				kheperas[robot]->run(20, walkTime);
			}
			else {
				walkTime = (int) (double)receivedData.p1 * (120.0 / 2000.0) * 1000000.0;
				kheperas[robot]->run(20, walkTime);
			}

			//usleep((int) ( (double)receivedData.p1 / 3.2) * 5.0 * 1000000.0);
			//kheperas[robot]->stop();

			//Faire marcher le robot
			break;

		case COMMANDE_TURN:
			printf("commande turn reçue par le robot %d\n", robot);

			kheperas[robot]->turn(angle);
			//usleep(1000000);
			break;
		default:
			printf("Commande inconnue recue %c \n", receivedData.commande);
			break;
		}

	}

	return NULL;
}


KheperaThread::~KheperaThread() {
	// TODO Auto-generated destructor stub
}



